//-----------------------------------------------------------------
// SX15-Evo Firmware di test con SX16
// Data : 25-01-06
// Versione : 1.0
// Area SX
// http://www.areasx.com
// Note     : per utilizzare il firmware collegare il connettore JP4
// della scheda SX15E al connettore Master In della scheda SX16
// ed impostare su ON i ponticelli 5 e 7 del DIP S3
//
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// ATTENZIONE!!!!:
// -*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// La libreria di Rabbit I2C.LIB, contenuta nella sottocartella Lib/I2C
// del compilatore Dynamic C contiene un errore nella funzione
// i2c_init(). In pratica anche definendo una diversa porta per l'i2c
// tramite i #define i2c_SCL_H() e seguenti, il port D viene comunque
// inizializzato, impedendo il corretto funzionamento della scheda.
// Per correggere l'errore  possibile effettuare nel file i2c.lib
// la modifica sotto riportata:
//
// Nella parte appena precedente la funzione i2c_init():
//
// // Define these to change basic bit handling
// #ifndef i2c_SCL_H()
// #define i2c_SCL_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSCLBit)
// #define i2c_SCL_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSCLBit)
// #define i2c_SDA_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSDABit)
// #define i2c_SDA_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSDABit)
// #define i2c_SCL()   BitRdPortI(PDDR,I2CSCLBit)
// #define i2c_SDA()   BitRdPortI(PDDR,I2CSDABit)
// #define I2C_DOINIT                   <<<----- AGGIUNGERE QUESTA RIGA!
// #endif
//
// Nella funzione i2c_init():
//
// void i2c_init()
// {
//
// #ifdef I2C_DOINIT                    <<<----- AGGIUNGERE QUESTA RIGA!
//
//  // Set the bits to tristate and the output to 0. Toggle using
//  //tristate reg.
//
// 	// This function affects the port D transfer transfer clock
// 	// Transfer clock on port D is PCLK/2
//
// 	WrPortI(PDCR,&PDCRShadow,0);
// 	BitWrPortI(PDFR ,&PDFRShadow ,0,I2CSCLBit);
// 	// Set the bits to normal function
// 	BitWrPortI(PDFR ,&PDFRShadow ,0,I2CSDABit);
// 	BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSCLBit);
// 	// Set the bits to input (=0)
// 	BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSDABit);
// 	BitWrPortI(PDDCR,&PDDCRShadow,1,I2CSCLBit);
// 	// Set the bits to Open Drain
// 	BitWrPortI(PDDCR,&PDDCRShadow,1,I2CSDABit);
// 	BitWrPortI(PDDR ,&PDDRShadow ,0,I2CSCLBit);
// 	// Set the outputs to 0, when outputs
// 	BitWrPortI(PDDR ,&PDDRShadow ,0,I2CSDABit);
//
// #endif                               <<<----- AGGIUNGERE QUESTA RIGA!
//
// 	i2c_clocks_per_us = (int)(19200L*32*freq_divider/1000000L);
// 	if(i2c_clocks_per_us < 3)
// 	{
// 		i2c_clocks_per_us = 3;
// 	}
// }
//
// Con la modifica sopra esposta il port D viene correttamente
// rilasciato per poter essere utilizzato dalla lettura ingressi.
//-----------------------------------------------------------------
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// Configurazione Firmware
//-----------------------------------------------------------------


//-----------------------------------------------------------------
// Define Hardware
//-----------------------------------------------------------------
#define LEDLD1_ON       BitWrPortI(PFDR,&PFDRShadow,1,1)
#define LEDLD1_OFF      BitWrPortI(PFDR,&PFDRShadow,0,1)
#define LEDLD2_ON       BitWrPortI(PFDR,&PFDRShadow,1,0)
#define LEDLD2_OFF      BitWrPortI(PFDR,&PFDRShadow,0,0)
#define LEDLD3_ON       BitWrPortI(PFDR,&PFDRShadow,1,4)
#define LEDLD3_OFF      BitWrPortI(PFDR,&PFDRShadow,0,4)

#define KEY_PRESSED   BitRdPortI(PEDR,1)

// Output channel
#define STROBE        BitWrPortI(PBDR,&PBDRShadow,1,5);BitWrPortI(PBDR,&PBDRShadow,0,5)
#define CLOCK         BitWrPortI(PBDR,&PFDRShadow,1,4);BitWrPortI(PBDR,&PFDRShadow,0,4)
#define SET_DATA      BitWrPortI(PBDR,&PFDRShadow,1,7)
#define CLEAR_DATA    BitWrPortI(PBDR,&PFDRShadow,0,7)

// Input channel
#define INP_LOADHI    BitWrPortI(PBDR,&PBDRShadow,1,3)
#define INP_LOADLO    BitWrPortI(PBDR,&PBDRShadow,0,3)
#define INP_CLOCKHI   BitWrPortI(PBDR,&PBDRShadow,1,0)
#define INP_CLOCKLO   BitWrPortI(PBDR,&PBDRShadow,0,0)
#define INP_DATA      BitRdPortI(PBDR,2)

#define I2CSCLBit 5       //Linea di clock PD5
#define I2CSDABit 4       //Linea Data PD4

// Sposta il port dell'I2C sul PortD
#define i2c_SCL_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSCLBit)
#define i2c_SCL_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSCLBit)
#define i2c_SDA_H() BitWrPortI(PDDDR,&PDDDRShadow,0,I2CSDABit)
#define i2c_SDA_L() BitWrPortI(PDDDR,&PDDDRShadow,1,I2CSDABit)
#define i2c_SCL()   BitRdPortI(PDDR,I2CSCLBit)
#define i2c_SDA()   BitRdPortI(PDDR,I2CSDABit)

#define DS1621_ADDRESS 0x00      // Indirizzo del sensore di temperatura


//-----------------------------------------------------------------
// Liberie
//-----------------------------------------------------------------
#use "I2C.LIB"


//-----------------------------------------------------------------
// Globali
//-----------------------------------------------------------------
char rxBuff[512];
char txBuff[512];
char tmpbuf[500];
int nchar;
int i;
float Temperature;
float Humidity;
char CurrentOutput;
unsigned long CurrentInput;

//-----------------------------------------------------------------
// Prototipi
//-----------------------------------------------------------------
void BoardInit(void);
void msDelay(unsigned int);
void SetOutput (int, int );
void SetGlobalOutput (int );
cofunc float DS1621Read(unsigned char);
int DS1621Init(unsigned char);
cofunc unsigned long GetGlobalInput(void);


//--------------------------------------------------------
// Ritardo bloccante
// Riceve      : ams - numero di millisecondi da ritardare
// Restituisce : -
// Note        :
//--------------------------------------------------------
nodebug
void msDelay(unsigned int ams)
{
  auto unsigned long t0;
  for(t0=MS_TIMER; MS_TIMER<ams+t0;);
}

//--------------------------------------------------------
// Inizializza i port del modulo RCM
// Riceve      : -
// Restituisce : -
// Note        :
//--------------------------------------------------------
void BoardInit() {

  // Port A
  // Default ingresso

  // Port B
  // PB0 - ICL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,0);
  // PB2 - IDA (input)
  // PB3 - IPL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,3);
  // PB4 - OCL (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,4);
  // PB5 - STR (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,5);
  // PB7 - ODA (output)
  BitWrPortI(PBDDR,&PBDDRShadow,1,7);

  // Port C
  // PC0-PC1 - Seriale D
  BitWrPortI(PCFR, &PCFRShadow, 1,0);

  // PC2-PC3 - Seriale C
  // Modem GSM
  BitWrPortI(PCFR, &PCFRShadow, 1,2);

  // Port D
  // PD4 - I2C SDA
  BitWrPortI(PDDDR, &PDDDRShadow, 0, I2CSDABit);
  BitWrPortI(PDDR,&PDDRShadow,0,I2CSDABit);
  // PD5 - I2C SCL
  BitWrPortI(PDDDR, &PDDDRShadow, 0, I2CSCLBit);
  BitWrPortI(PDDR,&PDDRShadow,0,I2CSCLBit);

  // Port E
  WrPortI(PEFR, &PEFRShadow, 0x00);
  // PE0 - DCD Modem GSM (ingresso)
  // PE1 - Pulsante esterno (ingresso)
  // PE4 - GSM Power Control (ingresso)
  // PE5 - RS485 Data Direction / RS232 DTR (output)
  BitWrPortI(PEDDR, &PEDDRShadow, 1,5);
  // PE7 - GSM On/Off (output)
  BitWrPortI(PEDDR, &PEDDRShadow, 1,7);

  // Port F
  WrPortI(PFFR, &PFFRShadow, 0x00);
  WrPortI(PFDCR, &PFDCRShadow, 0x00);
  // PF0 - Led LD3 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,0);
  // PF1 - Led LD1 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,1);
  // PF4 - Led LD2 (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,4);
  // PF5 - Modem Reset (output)
  BitWrPortI(PFDDR, &PFDDRShadow, 1,5);
  // PF6 - SH71 External I2c (bid)
  // PF7 - SH71 External I2c (bid)

  // Port G
  WrPortI(PGFR, &PGFRShadow, 0x00);
  // PG6-PG7 - Seriale E (RF Transmitter, Caller Id, GPS Receiver)
  BitWrPortI(PGFR, &PGFRShadow, 1,6);
  BitWrPortI(PGDDR, &PGDDRShadow, 0,7);
  BitWrPortI(PGDDR, &PGDDRShadow, 1,6);

}


//--------------------------------------------------------
// Imposta le uscite
// Riceve      : outstatus - stato da impostare per le uscite
// Restituisce : -
// Note        :
//--------------------------------------------------------
void SetGlobalOutput (int outstatus) {

  auto int i;
  auto int dato;

  #ifdef RF_VERSION

    RFTxBuf[0]=0x33;
    RFTxBuf[1]=0x01;
    RFTxBuf[2]=0x03;
    RFTxBuf[3]=0xFF;
    RFTxBuf[4]=outstatus;
    RFTxBuf[5]=0;

    if (rSendRFCommand(500)) {
      printf ("Impostazione globali riuscite\n");
    } else {
      printf ("Impostazione globali timed out\n");
    }

  #else

    for (i=7;i>=0;i--) {

      if (outstatus & (0x01<<i) ) {
        SET_DATA;
      } else {
        CLEAR_DATA;
      }

      CLOCK;
      #ifdef DEBUG_STRING
        printf ("Inviato bit [%d]\n",i);
      #endif
    }

    STROBE;
  #endif

}


//--------------------------------------------------------
// Imposta una uscita
// Riceve      : indice - indice dell'uscita da impostare (1-6)
//               val - stato da impostare (1 acceso, 0 spento)
// Restituisce : -
// Note        :
//--------------------------------------------------------
void SetOutput (int indice, int val) {

  if ((indice<1) || (indice>6)) {
    #ifdef DBG_STRING
      printf("Valore dell'indice errato\n");
    #endif
    return;
  }

  if (val)
    CurrentOutput |=(0x01<<(indice-1));
  else
    CurrentOutput &= ~(0x01<<(indice-1));

  #ifdef RF_VERSION
    RFTxBuf[0]=0x33;
    RFTxBuf[1]=0x01;
    RFTxBuf[2]=0x03;
    RFTxBuf[3]=indice;
    RFTxBuf[4]=val;
    RFTxBuf[5]=0;

    if (rSendRFCommand(500)) {
      printf ("Impostazione output riuscita\n");
    } else {
      printf ("Impostazione output timed out\n");
    }


  #else
    SetGlobalOutput(CurrentOutput);
  #endif

}


//--------------------------------------------------------
// Ricava gli ingressi
// Riceve      : -
// Restituisce : long con il bitmap degli ingressi
// Note        : In questa versione servono solo 16 ingressi,
//               quindi la funzione  customizzata
//--------------------------------------------------------
cofunc unsigned long GetGlobalInput(void) {

  auto int i;
  auto char latchval[4];
  unsigned long ret_val;

  #ifdef RF_VERSION
    RFTxBuf[0]=0x33;
    RFTxBuf[1]=0x01;
    RFTxBuf[2]=0x01;
    RFTxBuf[3]=0;
    RFTxBuf[4]=0;
    RFTxBuf[5]=0;
    wfd i=SendRFCommand(500);
    if (i==6) {
      latchval[0]=(RFRxBuf[3] ^ 0xFF);
      latchval[1]=(RFRxBuf[4] ^ 0xFF);
      latchval[2]=(RFRxBuf[5] ^ 0xFF);
      latchval[3]=0;
    } else {
      printf ("Lettura ingressi fallita\n");
    }
  #else
    // Carica gli ingressi dal registro
    INP_LOADLO;
    INP_LOADHI;

    latchval[0]=0;
    latchval[1]=0;
    latchval[2]=0;
    latchval[3]=0;
    for (i=0;i<24;i++) {

      if (INP_DATA){
        latchval[(int)(i/8)] |= 0x01;
      } else {
      }
      if (  (i!=7) && (i!=15) && (i!=23) ) {
        latchval[(int)(i/8)] <<= 0x01;
      }

      // Prossimo dato
      INP_CLOCKLO;
      INP_CLOCKHI;
    }
  #endif

  #ifdef DEBUG_STRING
    printf ("Latches [%d][%d][%d][%d] - [%X][%X][%X][%X]\n",latchval[0],latchval[1],latchval[2],latchval[3],latchval[0],latchval[1],latchval[2],latchval[3]);
  #endif
  ret_val=((unsigned long)latchval[2]<<16) | ((unsigned long)latchval[1]<<8) | (latchval[0]);
  #ifdef DEBUG_STRING
    printf ("retval [%lu]\n",ret_val);
  #endif
  return ret_val;


}



// -----------------------------------------------------------------------
// Inizializzazione del sensore di temperatura
// Riceve     : address: indirizzo I2C del sensore
// Restituisce: 1 se tutto OK, <=0 se ci sono errori
// -----------------------------------------------------------------------
int DS1621Init(unsigned char address){

  auto short int err;

  i2c_stop_tx();

  // Invia lo start
  if (err=i2c_startw_tx()){
    i2c_stop_tx();
    return -1;
  }

  // Indirizza il chip e attende la risposta
  if (err=i2c_wr_wait(0x90 + (address<<1))){
    i2c_stop_tx();
    return -2;
  }

  // Parametri di configurazione del DS1621

  // Invia il comando ACh (Access Config)
  if (err=i2c_write_char(0xAC)){
    i2c_stop_tx();
    return -3;
  }

  // Invia il Dato 02h
  if (err=i2c_write_char(0x2)){
    i2c_stop_tx();
    return -4;
  }

  // Invia lo start di sincronismo
  if (err=i2c_startw_tx()) {
    i2c_stop_tx();
    return -5;
  }

  // Indirizza il chip e attende la risposta
  if (err=i2c_wr_wait(0x90 + (address<<1))) {
    i2c_stop_tx();
    return -6;
  }

  // Invia il comando EEh che avvia le conversioni
  if (err=i2c_write_char(0xEE)){
    i2c_stop_tx();
    return -7;
  }

  // Chiusura
  i2c_stop_tx();
  return 1;

}


// -----------------------------------------------------------------------
// Funzione di lettura temperatura dal DS1621
// Riceve     : address - Indirizzo I2C
// Restituisce: valore di temperatura letto (float) se tutto OK, un valore
//              <-100 se errore
// -----------------------------------------------------------------------
cofunc float DS1621Read(unsigned char address) {

  auto unsigned char cnt;
  auto short int err,i;
  auto float temp;

  #ifdef RF_VERSION
    RFTxBuf[0]=0x33;
    RFTxBuf[1]=0x01;
    RFTxBuf[2]=0x02;
    RFTxBuf[3]=0;
    RFTxBuf[4]=0;
    RFTxBuf[5]=0;

    wfd i=SendRFCommand(500);
    if (i) {
      // Converto in float
      temp=0;
      // Imposto il mezzo grado
      if (RFRxBuf[4]==0x80) temp=0.5;

      if (RFRxBuf[3] & 0x80) {
        // Temperatura negativa
        temp+=(!RFRxBuf[3])+1;
        temp=-temp;
      } else {
        // Temperatura >0
        temp+=RFRxBuf[3];
      }

      printf ("Temperatura letta %.1f\n",temp);

    } else {
      printf ("Lettura temperatura timed out\n");
    }

  #else
    i2c_stop_tx();
    // Invia lo start di sincronismo
    if (err=i2c_startw_tx()) {
      i2c_stop_tx();
      return -101;
    }
    // Indirizza il chip
    if (err=i2c_wr_wait(0x90 + (address<<1))) {
      i2c_stop_tx();
      return -102;
    }
    // Invia il comando AAh (lettura dell'ultima temperatura campionata)
    if (err=i2c_write_char(0xAA)){
      i2c_stop_tx();
      return -103;
    }
    // Invia lo start di sincronismo
    if (err=i2c_startw_tx()) {
      i2c_stop_tx();
      return -104;
    }
    // Indirizzo  + linea RW/R a 1
    if (err=i2c_wr_wait(0x90 + (address<<1) + 1)){
      i2c_stop_tx();
      return -105;
    }

    for (cnt=0;cnt<2;cnt++)
    {
      err=i2c_read_char(&tmpbuf[cnt]);
      if (err){
        i2c_stop_tx();
        return -106;
      }
      if (cnt==1){
        i2c_send_nak();
      } else {
        i2c_send_ack();
      }
    }

    // Tutto Ok
    i2c_stop_tx();

    // Converto in float
    temp=0;
    // Imposto il mezzo grado
    if (tmpbuf[1]==0x80) temp=0.5;

    if (tmpbuf[0] & 0x80) {
      // Temperatura negativa
      temp+=(!tmpbuf[0])+1;
      temp=-temp;
    } else {
      // Temperatura >0
      temp+=tmpbuf[0];
    }
  #endif

  return (temp);
}



// -----------------------------------------------------------------------
// -----------------------------------------------------------------------
//                               MAIN
// -----------------------------------------------------------------------
// -----------------------------------------------------------------------
main () {

  char s[100];
  int cmd;

  // Inizializzazione Scheda
  BoardInit();

  // Impostazione allo stato di riposo di tutte le uscite
  SetGlobalOutput(0x00);

  // Inizializzazione libreria I2C
  i2c_init();
  
  // Inizializzazione del sensore di temperatura
  DS1621Init(DS1621_ADDRESS);

  printf ("SX15-Evo con SX16: System Ready\n");


  while (1) {

    costate {
      // Lampeggio del led
      LEDLD1_ON;
      waitfor (DelayMs(500));
      LEDLD1_OFF;
      waitfor (DelayMs(500));
    }

    costate {

      printf ("Cosa desideri fare?\n");
      printf ("1 - Lettura ingressi SX16\n");
      printf ("2 - Impostazione di una uscita SX16\n");
      printf ("3 - Lettura temperatura su SX16\n");

      printf("\nInserisci il comando da inviare e premi invio: ");
		  gets(s);
		  cmd = atoi(s);

      switch (cmd) {

      case 1:
        // Lettura ingressi
        printf ("Lettura degli ingressi su SX16\n");
        wfd CurrentInput=GetGlobalInput();
        
        printf ("---------------------------------------\n");
        printf ("Valore corrente degli ingressi:\n");
        for (i=0;i<24;i++) {
          if ( !(i % 8) || !(i % 16) ) {
            printf ("\n");
          }
          if (CurrentInput & (0x01L<<i)) {
            printf ("[%02d-ON ] ",i);
          } else {
            printf ("[%02d-OFF] ",i);
          }
          
        }
        printf ("\n---------------------------------------\n");
        
        break;

      case 2:
        // Impostazione uscite
        printf ("Numero dell'uscita da attivare (1-6)?\n");
		    gets(s);
		    cmd = atoi(s);
		    if ((cmd<1) || (cmd>6)) {
		      printf ("Errore. L'uscita deve essere compresa tra 1 e 6\n");
		    } else {
		      // Attivazione dell'uscita
		      printf ("---------------------------------------\n");
		      printf ("Attivo l'uscita per un secondo\n");
		      printf ("---------------------------------------\n");
		      SetOutput(cmd,1);
		      waitfor(DelayMs(1000));
		      SetOutput(cmd,0);
		    }

        break;

      case 3:
        // Lettura temperatura
        wfd Temperature=DS1621Read(0);
        
        printf ("---------------------------------------\n");
        printf ("Temperatura corrente: %.1f\n",Temperature);
        printf ("---------------------------------------\n");
        
        break;

      default:
        printf ("Comando sconosciuto\n\n");
        break;

      }


    }

  }

}